    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ----------------------------------
    028 * RenderingHintValueReadHandler.java
    029 * ----------------------------------
    030 * (C)opyright 2003, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: RenderingHintValueReadHandler.java,v 1.3 2005/10/18 13:33:32 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 03-Dec-2003 : Initial version
    040 * 11-Feb-2004 : Added missing Javadocs (DG);
    041 *
    042 */
    043
    044package org.jfree.xml.parser.coretypes;
    045
    046import java.awt.RenderingHints;
    047import java.lang.reflect.Field;
    048import java.lang.reflect.Modifier;
    049
    050import org.jfree.util.Log;
    051import org.jfree.xml.parser.AbstractXmlReadHandler;
    052import org.jfree.xml.parser.XmlReaderException;
    053import org.xml.sax.Attributes;
    054import org.xml.sax.SAXException;
    055
    056/**
    057 * A read handler for a rendering hint value.
    058 */
    059public class RenderingHintValueReadHandler extends AbstractXmlReadHandler {
    060
    061    /** The key under construction. */
    062    private Object key;
    063
    064    /** The value under construction. */
    065    private Object value;
    066
    067    /**
    068     * Creates a new read handler.
    069     */
    070    public RenderingHintValueReadHandler() {
    071        super();
    072    }
    073
    074    /**
    075     * Starts parsing.
    076     *
    077     * @param attrs  the attributes.
    078     *
    079     * @throws SAXException if there is a parsing error.
    080     */
    081    protected void startParsing(final Attributes attrs) throws SAXException {
    082        final String keyText = attrs.getValue("key");
    083        final String valueText = attrs.getValue("value");
    084        this.key = stringToHintField(keyText);
    085        this.value = stringToHintField(valueText);
    086    }
    087
    088    private Object stringToHintField (final String name) {
    089        final Field[] fields = RenderingHints.class.getFields();
    090        for (int i = 0; i < fields.length; i++) {
    091            final Field f = fields[i];
    092            if (Modifier.isFinal(f.getModifiers())
    093                && Modifier.isPublic(f.getModifiers())
    094                && Modifier.isStatic(f.getModifiers())) {
    095                try {
    096                    final String fieldName = f.getName();
    097                    if (fieldName.equals(name)) {
    098                        return f.get(null);
    099                    }
    100                }
    101                catch (Exception e) {
    102                    Log.info ("Unable to write RenderingHint", e);
    103                }
    104            }
    105        }
    106        throw new IllegalArgumentException("Invalid value given");
    107    }
    108
    109    /**
    110     * Returns the object for this element.
    111     *
    112     * @return the object.
    113     *
    114     * @throws XmlReaderException if there is a parsing error.
    115     */
    116    public Object getObject() throws XmlReaderException {
    117        return new Object[] {this.key, this.value};
    118    }
    119
    120    /**
    121     * Returns the key.
    122     *
    123     * @return the key.
    124     */
    125    public Object getKey() {
    126        return this.key;
    127    }
    128
    129    /**
    130     * Returns the value.
    131     *
    132     * @return the value.
    133     */
    134    public Object getValue() {
    135        return this.value;
    136    }
    137
    138}